/*

The stable lib1305 API functions are poly1305 and poly1305_verify.
Functions beginning lib1305_ (e.g., functions used for internal
tests and benchmarks) may change.

*/

#ifndef lib1305_h
#define lib1305_h

#ifdef __cplusplus
extern "C" {
#endif

#define poly1305 lib1305_onetimeauth_poly1305
#define poly1305_verify lib1305_onetimeauth_poly1305_verify
#define poly1305_BYTES lib1305_onetimeauth_poly1305_BYTES
#define poly1305_KEYBYTES lib1305_onetimeauth_poly1305_KEYBYTES

#define lib1305_version "20250407"
#define lib1305_arch "arm32"

extern void lib1305_cpuid(unsigned int *,long long);

#define lib1305_verify_BYTES 16

#define lib1305_verify_16_BYTES 16

#define lib1305_verify lib1305_verify_16
#define lib1305_dispatch_verify lib1305_dispatch_verify_16

extern int lib1305_verify_16(const unsigned char *,const unsigned char *);
extern int (*lib1305_dispatch_verify_16(long long))(const unsigned char *,const unsigned char *);

#define lib1305_verify_implementation lib1305_verify_16_implementation
#define lib1305_verify_compiler lib1305_verify_16_compiler
#define lib1305_dispatch_verify_implementation lib1305_dispatch_verify_16_implementation
#define lib1305_dispatch_verify_compiler lib1305_dispatch_verify_16_compiler
#define lib1305_numimpl_verify lib1305_numimpl_verify_16

extern const char *lib1305_verify_16_implementation(void);
extern const char *lib1305_verify_16_compiler(void);
extern const char *lib1305_dispatch_verify_16_implementation(long long);
extern const char *lib1305_dispatch_verify_16_compiler(long long);
extern long long lib1305_numimpl_verify_16(void);

#define lib1305_onetimeauth_BYTES 16
#define lib1305_onetimeauth_KEYBYTES 32

#define lib1305_onetimeauth_poly1305_BYTES 16
#define lib1305_onetimeauth_poly1305_KEYBYTES 32

#define lib1305_onetimeauth lib1305_onetimeauth_poly1305
#define lib1305_dispatch_onetimeauth lib1305_dispatch_onetimeauth_poly1305

extern void lib1305_onetimeauth_poly1305(unsigned char *,const unsigned char *,long long,const unsigned char *);
extern void (*lib1305_dispatch_onetimeauth_poly1305(long long))(unsigned char *,const unsigned char *,long long,const unsigned char *);

#define lib1305_onetimeauth_verify lib1305_onetimeauth_poly1305_verify
#define lib1305_dispatch_onetimeauth_verify lib1305_dispatch_onetimeauth_poly1305_verify

extern int lib1305_onetimeauth_poly1305_verify(const unsigned char *,const unsigned char *,long long,const unsigned char *);
extern int (*lib1305_dispatch_onetimeauth_poly1305_verify(long long))(const unsigned char *,const unsigned char *,long long,const unsigned char *);

#define lib1305_onetimeauth_implementation lib1305_onetimeauth_poly1305_implementation
#define lib1305_onetimeauth_compiler lib1305_onetimeauth_poly1305_compiler
#define lib1305_dispatch_onetimeauth_implementation lib1305_dispatch_onetimeauth_poly1305_implementation
#define lib1305_dispatch_onetimeauth_compiler lib1305_dispatch_onetimeauth_poly1305_compiler
#define lib1305_numimpl_onetimeauth lib1305_numimpl_onetimeauth_poly1305

extern const char *lib1305_onetimeauth_poly1305_implementation(void);
extern const char *lib1305_onetimeauth_poly1305_compiler(void);
extern const char *lib1305_dispatch_onetimeauth_poly1305_implementation(long long);
extern const char *lib1305_dispatch_onetimeauth_poly1305_compiler(long long);
extern long long lib1305_numimpl_onetimeauth_poly1305(void);

#ifdef __cplusplus
}
#endif

#endif
